"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = require("path");

var _vfile = _interopRequireDefault(require("vfile"));

var _remark = _interopRequireDefault(require("remark"));

var _remarkMdx = _interopRequireDefault(require("remark-mdx"));

var _remarkDocfreeHeadingLink = _interopRequireDefault(require("remark-docfree-heading-link"));

var _remarkDocfreePlayground = _interopRequireDefault(require("remark-docfree-playground"));

var _remarkDocfreeVue = _interopRequireDefault(require("remark-docfree-vue"));

var _remarkDocfreeProps = _interopRequireDefault(require("remark-docfree-props"));

var _remarkDocfreeJsx = _interopRequireDefault(require("remark-docfree-jsx"));

var _remarkEnhanceLink = _interopRequireDefault(require("remark-enhance-link"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default({
  content,
  resourcePath
}, {
  plugins,
  publicPath
}) {
  let headings = [];
  let remarkPlugins = [(0, _remark.default)().use(_remarkEnhanceLink.default, {
    publicPath
  }).use(_remarkDocfreeHeadingLink.default, {
    complete(data) {
      headings = data;
    }

  }).use(_remarkDocfreePlayground.default).use(_remarkDocfreeProps.default).use(_remarkDocfreeJsx.default).use(_remarkDocfreeVue.default).use(_remarkMdx.default)];

  if (Array.isArray(plugins)) {
    remarkPlugins = remarkPlugins.concat(plugins);
  }

  const processors = remarkPlugins.reduce((processor, plugin) => {
    if (plugin) {
      let opts = {};

      if (Array.isArray(plugin)) {
        opts = plugin[1] || {};
        plugin = plugin[0] || null;
      }

      if (typeof plugin === 'string') {
        if (!(0, _path.isAbsolute)(plugin)) {
          if (!plugin.startsWith('remark-')) {
            plugin = `remark-${plugin}`;
          }

          plugin = (0, _path.resolve)(process.cwd(), 'node_modules', plugin);
        }

        plugin = require(plugin);
        plugin = plugin.default || plugin;
      }

      return processor.use(plugin, opts);
    }

    return processor;
  });
  content = processors.processSync((0, _vfile.default)({
    contents: content,
    path: resourcePath
  })).toString();
  return {
    headings,
    content
  };
}